
#include <cstring>
#include "device.hpp"

const char *print_devtype(DeviceType dt) {
	switch (dt) {
	case PRINTER:         return "P"; break;
	case SCANNER:         return "SC"; break;
	case NETWRK_CAMERA:   return "NC"; break;
	case OH_DISPLAY:      return "D"; break;
	case USER_PDA:        return "U"; break;
	case SPEAKER:         return "SP"; break;
	case SMART_STORAGE:   return "SS"; break;
	case KBD:             return "K"; break;
	case MOUSE:           return "M"; break;
	case LCD_SCREEN:      return "LS"; break;
	case CD_PLAYER:       return "CP"; break;
	case MP3_PLAYER:      return "MP"; break;
	case E_BOOK:          return "EB"; break;
	default:              return "UNKNOWN"; break;
	}
}

DeviceType sttodev(const char *s) {
	if (!strcmp(s,"P"))         return PRINTER;
	else if (!strcmp(s,"SC"))   return SCANNER;
	else if (!strcmp(s,"NC"))   return NETWRK_CAMERA;
	else if (!strcmp(s,"D"))    return OH_DISPLAY;
	else if (!strcmp(s,"U"))    return USER_PDA;
	else if (!strcmp(s,"SP"))   return SPEAKER;
	else if (!strcmp(s,"SS"))   return SMART_STORAGE;
	else if (!strcmp(s,"K"))    return KBD;
	else if (!strcmp(s,"M"))    return MOUSE;
	else if (!strcmp(s,"LS"))   return LCD_SCREEN;
	else if (!strcmp(s,"CP"))   return CD_PLAYER;
	else if (!strcmp(s,"MP"))   return MP3_PLAYER;
	else if (!strcmp(s,"EB"))   return E_BOOK;
	else                        return UNKNOWN;
}
