#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cmath>

#include "utils.hpp"

extern char *devnames[];


void gengraph(GRAPH<SpecNode,int>& G, int d, int n, double R, mypoint *pall, node *vn)
{
  int edges = 0, i, j, k;

  for (i=0; i<n; i++) {
    pall[i].id = i+1;
    pall[i].x = uniform()*d;
    pall[i].y = uniform()*d;

    k = random() % DEVNUM;
    pall[i].name = devnames[k];

		SpecNode ss(i+1,sttodev(pall[i].name),i+1);

		node v = G.new_node(ss);
		vn[i] = v;
  }

  cout << n << endl << endl;

  for (i=0; i<n; i++) {
    cout << pall[i].id << ' ' << pall[i].name << ' ' << '-';
    for (j=0; j<n; j++) {
      double dd = pall[i].dist(pall[j]);
      if ((dd < R) && (dd != 0.0)) {
				G.new_edge(vn[i],vn[j],1);
				cout << ' ' << pall[j].id;
      }
    }
    cout << endl;
  }

  // cout << d << ' ' << n << ' ' << R << ' ' << edges << endl;
}

void assign_coord(GRAPH<SpecNode,int>& G, node_array<point>& pos, mypoint* pall, node *vn)
{
  for (int i=0; i<G.number_of_nodes(); i++) {
		point p = point(pall[i].x, pall[i].y);
		pos[vn[i]] = p;
	}
}

void gentaskgraph(GRAPH<TaskGNode,int>& TG, int d, int n, double R)
{
	int i, j, k;
	mypoint pall[n];
	node vn[n];

  for (i=0; i<n; i++) {
    pall[i].id = i+1;
    pall[i].x = uniform()*d;
    pall[i].y = uniform()*d;

    k = random() % DEVNUM;
    pall[i].name = devnames[k];

		TaskGNode tn(i+1,sttodev(pall[i].name));

		node v = TG.new_node(tn);
		vn[i] = v;
  }

  cout << n << endl << endl;

  for (i=0; i<n; i++) {
    cout << pall[i].id << ' ' << pall[i].name << ' ' << '-';
    for (j=0; j<n; j++) {
      double dd = pall[i].dist(pall[j]);
      if ((dd < R) && (dd != 0.0)) {
				TG.new_edge(vn[i],vn[j],1);
				cout << ' ' << pall[j].id;
      }
    }
    cout << endl;
  }

	/**** Add the user node to any of the device types ****/
	TaskGNode usn(n+1,USER_PDA);
	k = random() % n;
	node usrnode = TG.new_node(usn);
	TG.new_edge(usrnode, vn[k], 1);
}
